//Tool_SwissArmyGun.cs
//   By Amade (ID 10716) with coding reference from Zor (ID 160)

//If you want to create new modes, read the included "ModdingSupport" text file.

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	RTB_registerPref("Theme", "Swiss Army Gun", "$Pref::Server::SAGtheme", "list Wand 1 Fire 2 Bazooka 3 Gun 4", "Tool_SwissArmyGun", true, true, false); //Pref option name, pref category, pref variable, pref type (same as event registry), add-on name, default value, requires restart, host only
}
if(!strLen($Pref::Server::SAGtheme))
{
	$Pref::Server::SAGtheme = "Wand"; //Non-RTB users enter your pref here
}

//Default theme (Wand):
$SAGcolor = "0 0.5 1";
$SAGtrail = WandEmitterA;
$SAGexplosion = WandExplosion;
$SAGbullet = "base/data/shapes/empty.dts";
$SAGitem = "Add-Ons/Weapon_Gun/pistol.dts";
$SAGicon = "Add-Ons/Weapon_Gun/icon_gun";
$SAGeffect = printGunEmitter;
$SAGsound = printFireSound;
$SAGname = "Gun";

function LoadSAGtheme()
{
	switch($Pref::Server::SAGtheme)
	{
		case 1: %theme = "Wand";
		case 2: %theme = "Fire";
		case 3: %theme = "Bazooka";
		case 4: %theme = "Gun";
		default: %theme = $Pref::Server::SAGtheme;
	}
	switch$(%theme)
	{
		case "Wand":
			$SAGcolor = "0 0.5 1";
			$SAGtrail = WandEmitterA;
			$SAGexplosion = WandExplosion;
			$SAGbullet = "base/data/shapes/empty.dts";
			$SAGitem = "Add-Ons/Weapon_Gun/pistol.dts";
			$SAGicon = "Add-Ons/Weapon_Gun/icon_gun";
			$SAGeffect = printGunEmitter;
			$SAGsound = printFireSound;
		case "Fire":
			$SAGcolor = "1 0 0";
			$SAGtrail = AdminWandEmitterA;
			$SAGexplosion = AdminWandExplosion;
			$SAGeffect = AdminWandEmitterB;
		case "Bazooka":
			switch(forceRequiredAddOn(Weapon_Rocket_Launcher))
			{
				case $Error::AddOn_Disabled:
					RocketLauncherFlashEmitter.uiName = "";
					RocketLauncherSmokeEmitter.uiName = "";
					RocketTrailEmitter.uiName = "";
					RocketLauncherProjectile.uiName = "";
					RocketLauncherItem.uiName = "";
				case $Error::AddOn_NotFound:
					$SAGtheme = "Wand";
					LoadSAGtheme();
			}
			$SAGcolor = "0.1 0.5 0.25";
			$SAGtrail = RocketTrailEmitter;
			$SAGexplosion = RocketExplosion;
			$SAGbullet = "Add-Ons/Weapon_Rocket_Launcher/RocketProjectile.dts";
			$SAGitem = "Add-Ons/Weapon_Rocket_Launcher/RocketLauncher.dts";
			$SAGicon = "Add-Ons/Weapon_Rocket_Launcher/Icon_RocketLauncher";
			$SAGeffect = RocketLauncherFlashEmitter;
			$SAGsound = rocketFireSound;
			$SAGname = "Bazooka";
		case "Gun":
			switch(forceRequiredAddOn(Weapon_Gun))
			{
				case $Error::AddOn_Disabled:
					GunFlashEmitter.uiName = "";
					GunSmokeEmitter.uiName = "";
					GunExplosionEmitter.uiName = "";
					GunExplosionRingEmitter.uiName = "";
					GunProjectile.uiName = "";
					GunItem.uiName = "";
				case $Error::AddOn_NotFound:
					$SAGtheme = "Wand";
					LoadSAGtheme();
			}
			$SAGcolor = "0.25 0.25 0.25";
			$SAGbullet = "Add-Ons/Weapon_Gun/bullet.dts";
			$SAGtrail = "";
			$SAGexplosion = GunExplosion;
			$SAGsound = gunShot1sound;
			$SAGeffect = GunFlashEmitter;
	}
	return %theme;
}
LoadSAGtheme();

//Projectile//
datablock projectileData(SwissArmyGun_Projectile)
{
	projectileShapeName = $SAGbullet;

	directDamage     = 0;
	directDamageType = $DamageType::Default;

	explosion       = $SAGexplosion;
	particleEmitter = $SAGtrail;

	muzzleVelocity   = 200;
	velInheritFactor = 1;
	isBallistic      = false;

	armingDelay = 0;
	lifetime    = 2500;
	fadeDelay   = 2500;

	hasLight   = true;
	lightColor = $SAGcolor;
};

//Item//
datablock itemData(SwissArmyGun_Item)
{
	shapeFile = $SAGitem;
	emap      = true;

	category  = "Tools";
	className = "Weapon";

	doColorShift    = true;
	colorShiftColor = $SAGcolor SPC 1;

	image = SwissArmyGun_Image;

	mass       = 1;
	density    = 0.2;
	elasticity = 0.2;
	friction   = 0.6;

	canDrop  = true;
	iconName = $SAGicon;
	uiName   = "Swiss Army " @ $SAGname;
};

//Image//
datablock shapeBaseImageData(SwissArmyGun_Image)
{
   shapeFile = SwissArmyGun_Item.shapeFile;
   emap      = true;

   doColorShift    = true;
	colorShiftColor = SwissArmyGun_Item.colorShiftcolor;

   mountPoint = 0;
   offset     = "0 0 0";
   eyeOffset  = 0;
   rotation   = "0 0 0";

   correctMuzzleVector = true;
   melee               = false;

	item = SwissArmyGun_Item;
	className = "WeaponImage";
	showBricks = true; //Show invisible bricks while this is equipped?

	projectile     = SwissArmyGun_Projectile;
	projectileType = Projectile;
	armReady       = true;

	casing           = "";
	shellExitDir     = "0 0 0";
	shellExitOffset  = "0 0 0";
	shellExitVariance= 0; 
	shellVelocity    = 0;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "FireA";
	stateAllowImageChange[1]       = true;
	stateSequence[1]               = "Ready";

	stateName[2]                   = "FireA";
	stateFire[2]                   = true;
	stateTimeoutValue[2]           = 0.01;
	stateTransitionOnTimeout[2]    = "Check";
	stateSequence[2]               = "Fire";
	stateScript[2]                 = "onFire";
	stateEmitter[2]                = $SAGeffect;
	stateEmitterTime[2]            = 0.15;
	stateEmitterNode[2]            = "muzzleNode";
	stateSound[2]                  = $SAGsound;

	stateName[3]                   = "Check";
	stateSequence[3]               = "Reload";
	stateTransitionOnTriggerUp[3]  = "Ready";
	stateSequence[3]               = "Ready";
	stateTimeoutValue[3]           = 0.6;
	stateTransitionOnTimeout[3]    = "FireB";
	stateWaitForTimeout[3]         = false;

	stateName[4]                   = "FireB";
	stateTransitionOnTimeout[4]    = "FireB";
	stateTransitionOnTriggerUp[4]  = "Ready";
	stateTimeoutValue[4]           = 0.1;
	stateFire[4]                   = true;
	stateAllowImageChange[4]       = false;
	stateSequence[4]               = "Ready";
	stateScript[4]                 = "onFire";
	stateEmitter[4]                = $SAGeffect;
	stateEmitterTime[4]            = 0.075;
	stateEmitterNode[4]            = "muzzleNode";
	stateSound[4]                  = $SAGsound;
};

function SwissArmyGun_Image::onMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);
	if(isObject(%client = %obj.getControllingClient()))
	{
		if(!strLen(%client.SAGhelp))
		{
			%client.SAGhelp = true;
		}
		if(!%client.hasHeard["Intro"] && %client.SAGhelp != 0)
		{
			%client.hasHeard["Intro"] = true;
			messageClient(%client, '', "\c2It would seem you've stumbled upon a \c3Swiss Army " @ $SAGname @ "\c2!");
			messageClient(%client, '', "\c2You can use the command \c3/SAGmode \c5<mode name>\c2 to select a mode.");
			messageClient(%client, '', "\c2Enter the command \c3/SAGhelp \c2 for a list of modes, or add \c5<on/off>\c2 to toggle help messages.");
		}
	}
}

function SwissArmyGun_Image::onFire(%this, %obj, %slot)
{
	if(isFunction(%fn = "SwissArmyGun_" @ %obj.getControllingClient().SAGmode @ "_onFire"))
	{
		call(%fn, %obj, %slot);
		return 0;
	}
	%holdingSAG = %obj.getMountedImage(%slot) == SwissArmyGun_Image.getID() ? true : false;
	%vel = vectorScale((%holdingSAG ? %obj.getMuzzleVector(%slot) : %obj.getEyeVector()), 200);
	%start = %holdingSAG ? %obj.getMuzzlePoint(%slot) : %obj.getEyePoint();
	%proj = new Projectile()
	{
		dataBlock = SwissArmyGun_Projectile;
		initialVelocity = %vel;
		initialPosition = %start;
		sourceObject = %obj;
		launch = getSimTime();
		client = %obj.getControllingClient();
		sourceSlot = %slot;
	};
	MissionGroup.add(%proj);
	//Raycast
	%end = vectorAdd(%start, vectorScale(%vel, 2.5));
	%typemasks = $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType;
	%raycast = containerRaycast(%start, %end, %typemasks, %obj);
	if(isObject(%col = firstWord(%raycast)))
	{
		%pos = posFromRaycast(%raycast);
		SwissArmyGunCollision(%obj, %col, %pos);
		%dist = vectorDist(%startPos, %pos);
		%rate = vectorLen(%vel);
		%time = (%dist / %rate) * 1000;
		%proj.schedule(%time, explode);
	}
	return %proj;
}

function SwissArmyGunCollision(%obj, %col, %pos)
{
	%type = %col.getType();
	if(%type & $TypeMasks::FxBrickAlwaysObjectType)
	{
		%name = "Brick";
	}
	if(%type & $TypeMasks::PlayerObjectType)
	{
		%name = "Player";
	}
	if(%type & $TypeMasks::VehicleObjectType)
	{
		%name = "Vehicle";
	}
	if(%type & $TypeMasks::InteriorObjectType)
	{
		%name = "Interior";
	}
	if(%type & $TypeMasks::TerrainObjectType)
	{
		%name = "Terrain";
	}
	if(isFunction(%fn = "SwissArmyGun_" @ %obj.getControllingClient().SAGmode @ "_" @ %name))
	{
		call(%fn, %obj, %col, %pos);
	}
	return %name;
}

exec("./Mode_BLtools.cs");
exec("./Mode_DefaultTools.cs");

function serverCmdSAGmode(%client, %modename)
{
	%modename = strLwr(%modename);
	%client.SAGmode = %modename;
	if(strLen(%modeName) == 0)
	{
		messageClient(%client, '', "<color:ff0000>You need to enter a mode name.");
		return;
	}
	if(strLen(%str = $SwissArmyGun::Mode_[%modeName]) > 0 )
	{
		if(%client.SAGhelp != 0)
		{
			messageClient(%client, '', "\c2Now using Swiss Army Gun mode \"\c3" @ %modename @ "\c2\".");
			if(!%client.hasHeard[%modename])
			{
				%client.hasHeard[%modename] = true;
				for(%i = 0; %i < getFieldCount(%str); %i++)
				{
					if(%i == 0)
					{
						messageClient(%client, '', "\c2 - Object types this mode has an effect on:");
					}
					messageClient(%client, '', "\c2  " @ %i + 1 @ ". " @ getField(%str, %i));
				}
				if(%i == 0)
				{
					messageClient(%client, '', "\c2-This mode does not seem to have an effect on any type of object.");
				}
				if(strLen(%str = $SwissArmyGun::ModeWelcome_[%modeName]) > 0)
				{
					for(%i = 0; %i < getFieldCount(%str); %i++)
					{
						messageClient(%client, '', "\c2" @ getField(%str, %i));
					}
				}
			}
		}
	}
	else
	{
		messageClient(%client, '', "<color:ff0000>The mode you have entered (\c3" @ %modename @ "<color:ff0000>) does not appear to be a valid mode.");
		if(%client.SAGhelp != 0)
		{
			messageClient(%client, '', "<color:ff0000>You can enter \c3/SAGhelp<color:ff0000> to view a list of modes.");
		}
	}
}

package SwissArmyGun_ModeSwitcher
{
	function serverCmdLight(%client)
	{
		if(isObject(%obj = %client.player))
		{
			if(%obj.getMountedImage(0) == SwissArmyGun_Image.getID())
			{
				if(strLen($SwissArmyGun::ModeNo[%client.SAGmodeN++]) == 0)
				{
					%client.SAGmodeN = 1;
				}
				%client.SAGmode = $SwissArmyGun::ModeNo[%client.SAGmodeN];
				if(strLen(%str = $SwissArmyGun::Mode_[%client.SAGmode]) > 0)
				{
					//This triggers even without help as otherwise they wouldn't know what mode they were using
					messageClient(%client, '', "\c2Now using Swiss Army Gun mode \"\c3" @ %client.SAGmode @ "\c2\".");
					if(%client.SAGhelp != 0)
					{
						if(!%client.hasHeard[%client.SAGmode])
						{
							%client.hasHeard[%client.SAGmode] = true;
							for(%i = 0; %i < getFieldCount(%str); %i++)
							{
								if(%i == 0)
								{
									messageClient(%client, '', "\c2 - Object types this mode has an effect on:");
								}
								messageClient(%client, '', "\c2  " @ %i + 1 @ ". " @ getField(%str, %i));
							}
							if(%i == 0)
							{
								messageClient(%client, '', "\c2 - This mode does not seem to have an effect on any type of object.");
							}
							if(strLen(%str = $SwissArmyGun::ModeWelcome_[%client.SAGmode]) > 0)
							{
								for(%i = 0; %i < getFieldCount(%str); %i++)
								{
									messageClient(%client, '', "\c2" @ getField(%str, %i));
								}
							}
						}
					}
				}
				return;
			}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(SwissArmyGun_ModeSwitcher);

function serverCmdSAG(%client, %arg1, %arg2)
{
	if(isObject(%obj = %client.player))
	{
		if(!strLen(%arg1) || %arg2 !$= "")
		{
			%obj.updateArm(SwissArmyGun_Image);
			%obj.mountImage(SwissArmyGun_Image, 0);
		}
		if(strLen(%arg1))
		{
			%client.hasHeard[%arg1] = true;
			serverCmdSAGmode(%client, %arg1);
			SwissArmyGun_Image.onFire(%obj, 0);
		}
	}
}

function serverCmdSAGhelp(%client, %arg)
{
	if(strLen(%arg) > 0)
	{
		switch$(strLwr(%arg))
		{
			case "on": %client.SAGhelp = 1;
			case "off": %client.SAGhelp = 0;
			default: %client.SAGhelp = %client.SAGhelp == 0 ? 1 : 0;
		}
		%bool = %client.SAGhelp ? "ON" : "OFF";
		messageClient(%client, '', "\c2You have turned Swiss Army Gun help features \c3" @ %bool @ "\c2.");
		return %client.SAGhelp;
	}
	messageClient(%client, '', "\c3Registered Modes:");
	for(%i = 1; $SwissArmyGun::ModeNo[%i] !$= ""; %i++)
	{
		messageClient(%client, '', "\c3  " @ %i @ ".\c2 " @ $SwissArmyGun::ModeNo[%i]);
	}
}

function serverCmdSpawnWithSAG(%client, %arg)
{
	switch$(strLwr(%arg))
	{
		case "true": %arg = 1;
		case "false": %arg = 0;
		case "1": %arg = 1;
		case "0": %arg = 0;
		case "on": %arg = 1;
		case "off": %arg = 0;
		default: messageClient(%client, '', "<color:ff0000>\"\c3" @ %arg @ "<color:ff0000>\" is not a valid argument for that command."); return 0;
	}
	%client.spawnWithSAG = %arg;
	switch(%arg)
	{
		case 1: %msg = "\c2You will now spawn with a Swiss Army Gun instead of the default tools. (Use \c3/SpawnWithSAG \c0<on/off>\c2 to change)";
		case 0: %msg = "\c2You will now spawn with the default tools. (Use \c3/SpawnWithSAG \c0<on/off>\c2 to change)";
	}
	messageClient(%client, '', %msg);
	return 1;
}

package SwissArmyGun_Default
{
	function Player::GiveDefaultEquipment(%this)
	{
		if(!%this.client.spawnWithSAG || !%this.getDatablock().maxTools)
		{
			return parent::GiveDefaultEquipment(%this);
		}
		%this.clearTools();
		%id = SwissArmyGun_Item.getID();
		%this.tool[0] = %id;
		%this.weaponCount++;
		if(isObject(%this.client))
		{
			messageClient(%this.client, 'MsgItemPickup', "", 0, %id);
		}
	}
	function serverCmdUseSprayCan(%client, %can)
	{
		%mode = strlwr(%client.SAGmode);
		if(%client.player.getMountedImage(0) == SwissArmyGun_Image.getID() && %mode $= "paint" || %mode $= "fillcan")
		{
			%remount = 1;
		}
		parent::serverCmdUseSprayCan(%client, %can);
		%client.currentFxCan = 0;
		if(%remount)
		{
			%client.player.mountImage(SwissArmyGun_Image, 0);
		}
	}
	function serverCmdUseFxCan(%client, %can)
	{
		%mode = strlwr(%client.SAGmode);
		if(%client.player.getMountedImage(0) == SwissArmyGun_Image.getID() && %mode $= "paint" || %mode $= "fillcan")
		{
			%remount = 1;
		}
		parent::serverCmdUseFxCan(%client, %can);
		%client.currentFxCan = %can + 1;
		if(%remount)
		{
			%client.player.mountImage(SwissArmyGun_Image, 0);
		}
	}
	function Player::MountImage(%this, %image, %slot, %loaded, %skinName)
	{
		if(strPos(%image.getName(), "SprayCan") != -1 && %this.getMountedImage(%slot) == SwissArmyGun_Image.getID())
		{
			%mode = strLwr(%this.getControllingClient().SAGmode);
			if(%mode $= "paint" || %mode $= "fillcan")
			{
				return 0;
			}
		}
		return parent::mountImage(%this, %image, %slot, %loaded, %skinName);
	}
};
activatePackage(SwissArmyGun_Default);